#!/usr/bin/env python
#
#       getDData.py
#       Extracts definitions.
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
import os

def main():

	dtext = file("pgwht04.txt").read().split("<h1>") #h1 marks new words.
	makeDir("a")
	makeDir("b")
	makeDir("c")
	makeDir("d")
	makeDir("e")
	makeDir("f")
	makeDir("g")
	makeDir("h")
	makeDir("i")
	makeDir("j")
	makeDir("k")
	makeDir("l")
	makeDir("m")
	makeDir("n")
	makeDir("o")
	makeDir("p")
	makeDir("q")
	makeDir("r")
	makeDir("s")
	makeDir("t")
	makeDir("u")
	makeDir("v")
	makeDir("w")
	makeDir("x")
	makeDir("y")
	makeDir("z")

	started = False # only after A.
	
	for i in range(len(dtext)):
		data = dtext[i]
		
		word = data[:data.find("</h1>")]
		definition = ""
		while (data.find("<def>") > -1): #Add to definitions, and trim.
			definition += data[data.find("<def>")+5:data.find("</def>")] + "\n"
			data = data[data.find("</def>")+4:] # trim
		
		if (not(started)):
			if (word == "A"):
				started = True
		if (started):
			#output word, definition
			exist = True
			try: # in cases where there is more than one entry, keep the FIRST:
				test = file(word[0].lower() + "/" + word)
			except:
				exist = False # Can't find file, ok to write.
			if (not(exist) and str.isalpha(word) and len(definition) > 80): # don't get words with non-alphabetic.
				try:
					out = file(word[0].lower() + "/" + word.replace("/",""),'w')
					out.write(definition)
				except:
					pass # skip files that make filesystem error.
				
				

	return 0

def makeDir(name):
	try:
		os.mkdir(os.path.join(os.getcwd(),name))
	except:
		pass

if __name__ == '__main__': main()
